#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "/usr/include/Neon/Neon.h"
using namespace std;

int checkRoot()
{
    int user;
    user = getuid();
    if(user)
        return false;

    return true;
}

int showResult(int result, const char* pretext)
{
	if(result == COMMON_ERROR)
		cout << pretext<<" failed!"<<endl;
	else if (result == FUN_UNSUPPORT)
		cout << pretext<<" unsupport!"<<endl;
	else
		return true;
	
	return false;
}


int main(int ,char* [])
{
    if(!checkRoot())
    {
        cout << "Need root privileges, please use sudo command..."<<endl;
        return 0;
    }

    char version[256];
    cout << "\nGet Neon Device Information" << endl;
    int result=Neon_GetDeviceInfo(version,sizeof(version));
    if(showResult(result, "Neon_GetDeviceInfo"))
        cout << version << endl;    

    unsigned int val=0;
    int ival=0;
    result=Neon_GetDINums(&val);
	if(showResult(result, "Neon_GetDINums"))
        cout << "DI Nums:"<<val<< endl;	

    for(unsigned int i=0;i<(unsigned int)val;i++)
    {
        int state=0;
		char text[128];
		sprintf(text, "Neon_GetDIState %d", i);
        result=Neon_GetDIState(i,&state);
		if(showResult(result, text))
			cout << "DI"<<i<<"state:"<<state<<endl;        		
		
		sprintf(text, "Neon_GetDITriggerPolarity %d", i);
        result=Neon_GetDITriggerPolarity(i,&state);
		if(showResult(result, text))
			cout << "DI"<<i<<" TriggerPolarity:"<<state<<endl;        
    }

    result=Neon_GetDIO0Config(&ival);
	if(showResult(result, "Neon_GetDIO0Config"))
        cout << "DIO0 Config:"<<ival<< endl;

    result=Neon_GetDONums(&val);
	if(showResult(result, "Neon_GetDONums"))
        cout << "DO Nums:"<<val<< endl;    

    for(unsigned int i=0;i<(unsigned int)val;i++)
    {
        int state=0;
		char text[128];
		sprintf(text, "Neon_GetDOState %d", i);
        result=Neon_GetDOState(i,&state);
		if(showResult(result, text))
			cout << "DO"<<i<<"state:"<<state<<endl;
    }

    result=Neon_GetStrobeOutEnable(&ival);
	if(showResult(result, "Neon_GetStrobeOutEnable"))
        cout << "StrobeOut Enable:"<<ival<< endl;

    result=Neon_GetStrobeOutDelay(&val);
	if(showResult(result, "Neon_GetStrobeOutDelay"))
        cout << "StrobeOut delay:"<<val<<"us"<< endl;    

    result=Neon_GetStrobeOutPulseWidth(&val);
	if(showResult(result, "Neon_GetStrobeOutPulseWidth"))
        cout << "StrobeOut pulse width:"<<val<<"us"<< endl;	

	result=Neon_GetStrobeOutInvertedPolarity(&ival);
	if(showResult(result, "Neon_GetStrobeOutInvertedPolarity"))
        cout << "StrobeOut Inverted Polarity:"<<ival<< endl;	
	
    result=Neon_GetExposureDelay(&val);
	if(showResult(result, "Neon_GetExposureDelay"))
        cout << "Exposure delay:"<<val<<"us"<< endl;    

    result=Neon_GetDebounceTime(&val);
	if(showResult(result, "Neon_GetDebounceTime"))
        cout << "Get Debounce time:"<<val<<"x40ns"<< endl;


    return 0;
}

