import ctypes  
import os, sys
import time

#The following code shows how to call the sdk library in the python

if not os.geteuid()==0:
	sys.exit("Need root privileges, please use sudo command...")

#def Get DO
def GetDO(i):
	DOState = ctypes.c_int(0)
	lib.Neon_GetDOState(ctypes.c_int(i), ctypes.byref(DOState))	
	return DOState.value

def SetDO(i, val):
	lib.Neon_SetDOState(ctypes.c_int(i), ctypes.c_int(val))


#def Set DO
#list information
loadclib = ctypes.cdll.LoadLibrary   
lib = loadclib("/usr/lib/Neon/libNeon.so")  #Change lib here
libc = loadclib("libc.so.6")   
versionstr = ctypes.create_string_buffer(256)
lib.Neon_GetDeviceInfo(versionstr,ctypes.sizeof(versionstr))
libc.printf(b"%s",versionstr);

#Get nums of DO
DONums = ctypes.c_int(0)
lib.Neon_GetDONums(ctypes.byref(DONums))
print("DO nums:"+ str(DONums.value))

#Get nums of DI
DINums = ctypes.c_int(0)
lib.Neon_GetDINums(ctypes.byref(DINums))
print("DI nums:" + str(DINums.value))

#Get DI
DIindex = ctypes.c_int(0)
DIState = ctypes.c_int(0)
for i in range(DINums.value):
	DIState.value = 0
	lib.Neon_GetDIState(ctypes.c_int(i), ctypes.byref(DIState))
	print("DI"+str(i)+" state:"+ str(DIState.value))

#Set DO 1, *The index of DO is zero based, DO0 is the first DO
print("Set DO1 state:0")
SetDO(1, 0)

time.sleep(1/2.0)

#Set DO 1
print("Set DO1 state:1")
SetDO(1, 1)
