#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "/usr/include/Neon/Neon.h"
using namespace std;

int checkRoot()
{
    int user;
    user = getuid();
    if(user)
        return false;

    return true;
}

void printfusage()
{
    cout<<"Usage:"<<endl;
    cout<<"NeonSet [Options] [Val1] [Val2] ..."<<endl;
    cout<<endl;
    cout<<" [OPtions]=DO, 						[Val1]=index [Val2]=1/0 "<<endl;
	cout<<" [OPtions]=DITriggerPolarity, 		[Val1]=index [Val2]=2/1/0"<<endl;	
    cout<<" [OPtions]=DIO0Config,            	[Val]=1/0"<<endl;		
    cout<<" [OPtions]=StrobeOutEnable,          [Val]=1/0"<<endl;
    cout<<" [OPtions]=StrobeOutDelay,           [Val]=0 - 4294967295, map to 1 - 4294967296 us "<<endl;
    cout<<" [OPtions]=StrobeOutPulseWidth,      [Val]=0 - 4294967295, map to 1 - 4294967296 us "<<endl;
	cout<<" [OPtions]=StrobeOutInvertedPolarity,[Val]=1/0"<<endl;
    cout<<" [OPtions]=ExposureDelay,            [Val]=0 - 4294967295 us "<<endl;
    cout<<" [OPtions]=DebounceTime,             [Val]=0 - 16777215, 0 is by pass, others: (1 - 16777215) * 40ns "<<endl;
}

int main(int argc,char *argv[])
{
    if(!checkRoot())
    {
        cout << "Need root privileges, please use sudo command..."<<endl;
        return 0;
    }

    if(argc<3)
    {
        printfusage();
        return 0;
    }
    string opt,val,statestr;
    opt=argv[1];
    val=argv[2];
    if(argc>3)
        statestr=argv[3];

    unsigned int value;
    int state,result;

    try
    {
        value=(unsigned int)strtoul(val.c_str(),NULL,0);
    }
    catch(...)
    {
        printfusage();
        return 0;
    }

    if(opt=="DO")
    {
        try
        {
            state=atoi(statestr.c_str());
        }
        catch(...)
        {
            printfusage();
            return 0;
        }

        if(state>0)
            state=1;
        else
            state=0;

        result=Neon_SetDOState(value,state);

    }
    else if(opt=="DITriggerPolarity")
    {
        try
        {
            state=atoi(statestr.c_str());
        }
        catch(...)
        {
            printfusage();
            return 0;
        }
		
		if(state <0 || state >2)
		{
            printfusage();
            return 0;
        }			
		
        result=Neon_SetDITriggerPolarity(value,state);		
    }		
    else if(opt=="DIO0Config")
    {
        result=Neon_SetDIO0Config(value);
    }
    else if(opt=="StrobeOutDelay")
    {
        result=Neon_SetStrobeOutDelay(value);
    }
    else if(opt=="StrobeOutPulseWidth")
    {
        result=Neon_SetStrobeOutPulseWidth(value);
    }
	else if(opt=="StrobeOutInvertedPolarity")
    {
        result=Neon_SetStrobeOutInvertedPolarity(value);
    }
    else if(opt=="ExposureDelay")
    {
        result=Neon_SetExposureDelay(value);
    }
    else if(opt=="DebounceTime")
    {
        result=Neon_SetDebounceTime(value);
    }
    else if(opt=="StrobeOutEnable")
    {
        result=Neon_SetStrobeOutEnable(value);
    }
    else
    {
        printfusage();
        return 0;
    }

    if(result==COMMON_ERROR)
    {
        cout<<"Error!"<<endl;
    }
	else if(result==FUN_UNSUPPORT)
    {
        cout<<"Unsupport!"<<endl;
    }
    else
    {
        cout<<"Success!"<<endl;
    }

    return 0;
}

